Bug 859119 - Potential HA broker message duplication when deleting a queue with an alt-exchange
Potential HA broker message duplication when deleting a queue with an alt-exc...
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: qpid-cpp (Show other bugs)
Unspecified Unspecified
medium Severity unspecified
: 3.0
: ---
Assigned To: Alan Conway
Irina Boverman
: OtherQA
Depends On:
Blocks: 698367
  Show dependency treegraph
Reported: 2012-09-20 11:23 EDT by Jason Dillaman
Modified: 2014-09-24 11:04 EDT (History)
5 users (show)

See Also:
Fixed In Version: qpid-cpp-0.22-30
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2014-09-24 11:04:45 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
test script (1.90 KB, application/x-shellscript)
2014-02-26 11:27 EST, Irina Boverman
no flags Details

  None (edit)
Description Jason Dillaman 2012-09-20 11:23:45 EDT
Description of problem:
When deleting a queue with an alternate exchange, both the primary and the backup brokers will route messages to the alt-exchange when the queue is deleted.  This will cause the backups to potentially receive duplicate copies of the message if the alt-exchange is bound to a replicated queue (one set from the local route to the alt-exchange and another from the primary due to its route to the alt-exchange).  Suggest that the backup brokers should not route messages to the alt-exchange when a queue is deleted.  

Additionally, for auto-delete queues with an alt-exchange, upon loss of a primary, the backup brokers should not immediately start the auto-delete process.  Instead, the backups should wait for the promotion of a new primary.  Upon selection of the new primary, the auto-delete process can start so that the new primary will route the messages to the alt-exchange and the backups will not route the messages to the alt-exchange.

Version-Release number of selected component (if applicable):
Qpid 0.18

How reproducible:
Backup needs to receive the QMF queue delete event prior to receiving the queue's deque replication events.

Steps to reproduce:
1) Bind queue test0 to amq.fanout
2) Create queue test1 with an alt-exchange to amq.fanout
3) Send a message to test1
4) Delete queue test1

Actual results:
The queue test0 will have 1 message on the primary host but 2 messages on the backups

Expected results:
The queue test0 will have 1 message on all hosts
Comment 1 Alan Conway 2013-12-10 12:14:32 EST
Fixed on 0.22-mrg-aconway-bz859119
(Based on 0.22-mrg-aconway-bz1030608)
Comment 4 Irina Boverman 2014-02-26 11:27:55 EST
Created attachment 868100 [details]
test script
Comment 5 errata-xmlrpc 2014-09-24 11:04:45 EDT
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.


Note You need to log in before you can comment on or make changes to this bug.